
# Firefox

Eigentlich macht Neo mit Firefox keine Probleme. 
Bei Addons kann das aber vorkommen.

## VimFX
[VimFX](https://addons.mozilla.org/en-US/firefox/addon/vimfx/) ist ein nützliches Addon, das die Firefox-Tastenkürzel an vim anpasst (und dadurch das Arbeiten ein wenig schneller macht).

### Hintkeys
VimFX hat ein sinnvolles Hintkey-Konzept, allerdings nur für Qwertz. Unter Preferences → Hint Chars lassen sich die Tasten für Neo anpassen.

## PentaDactyl
[Pentadactyl](http://5digits.org/pentadactyl/index) ist ein sehr fortschrittliches Addon, ähnlich dem bekannteren [Vimperator](http://www.vimperator.org/vimperator).
Firefox wird weitreichend geändert, z.B. bei Teilen der Benutzeroberfläche wie Menüs, Buttons und Extrakomponenten zum anonymen Surfen.

### Insert geht nicht
!!! todo "Info"
    Verweise auf V2 / V2-flux sind noch nicht eingetragen.

Wenn man [V2](V2) oder [V2-flux](V2flux) *Insert* über Ebene4 eingibt, aktiviert das den *Caret Mode* nicht. Die Ursache dafür ist noch nicht bekannt. Shift-Insert (der Clipboard-Zugang) funktioniert dagegen problemlos.

Vorerst muss man alternativ *i* benutzen (tut dasselbe).

### Hintkeys
Pentadactyl benutzt standardmäßig die Zahlen 0-9 als Hintkeys. Leider muss man dafür entweder in die Zahlenreihe oder über Mod4 ein zusätzliches Zeichen eingeben. Glücklicherweise kann man das mit der Option `:set hk` ändern. Wer aber erwartet, dass Neo oder wenigstens Belegungen wie Colemak unterstützt werden, wird enttäuscht.
Statt fortschrittlichen Alternativen findet man als vorgeschlagen Wert nur (wieder einfach von links nach rechts) das greuliche Qwertz.
  
  
Lösung:
```
:set hk=enirtsobah
:mkp!
```
Diese Variante ist für Bone und V2 geeignet und entlastet die kleinen Finger.

### Belegungsvorschläge
In allen Neo2-Varianten (einschließlich Cry, Bone, AdNW, V2) liegt „e“ auf einer guten Position auf der Grundlinie.  
Da in Pentadactyl dieser Buchstabe nicht belegt ist, bietet es sich an, das Tastenkürzel zu setzen.  
Hier wird beispielsweise f (für Hintkeys) auf e gelegt:

```
:nm -builtin e f
:nm -builtin E F
:mkp!
```

### Mac OS: Dritte Ebene
Die dritte Ebene wird von Firefox scheinbar so interpretiert, als werde zusätzlich *Alt* gedrückt. Dieses Problem betrifft nicht nur Vimperator/Pentadactyl, stört hier aber besonders (wegen *:*, */*). 'LarsHuluk' schlägt [folgende Lösung](https://git.neo-layout.org/neo/neo-layout/issues/172#issuecomment-1392) vor:

```
:command NeoNRemap -nargs=1 :nmap <A-<args>> <args>
:NeoNRemap :
:NeoNRemap @
:NeoNRemap /
usw.
```
