 

# LaTeX und Neo
Der typische (La)TeX-Nutzer profitiert in vielfacher Weise vom Neo-Tastaturlayout: Neben den ergonomischen Anordnung der Buchstaben sind beispielsweise auch die häufiger benötigten Sonderzeichen wie \{}[]|$ viel besser erreichbar.

Um in einer *(La)TeX-Datei* jedoch auch die vielen typografischen Sonderzeichen der Neo-Tastaturbelegung (z. B. deutsche/französische/englische Anführungszeichen, Gedankenstrich, Auslassungspunkte, griechische Buchstaben, mathematische Symbole, …) direkt eingeben zu können, so dass sie anschließend auch korrekt im Ausgabedokument (*PDF* oder *PS* oder …) dargestellt werden, muss man jedoch ein paar Dinge wissen und beachten.

Alle hier vorgestellten Pakete und Programme zielen darauf ab, darüber hinaus auch die Unicode-Zeichen auf der Neo-Tastatur direkt in LaTeX eingeben zu können.

## XeTeX
XeTeX ist eine Weiterentwicklung aus εTeX und TeXGX, die neben nativer Unicode-Unterstützung auch die einfache Nutzung moderner Schriftformate (TrueType, OpenType) und ihrer Vorteile (bspw. Ligaturen und Variationen in OpenType-Fonts) ermöglicht. [Hier](../src/branch/master/latex/XeTeX/) befindet sich ein einfaches Beispiel, das genau diese Features demonstriert.
Da XeTeX nicht in der Entwicklungslinie von pdfTeX steht (aber auch pdfs erzeugt), sind mikrotypografische Erweiterungen, die das Paket microtype bietet (Optischer Randausgleich, character protusion etc.), leider nicht verfügbar; die allermeisten Pakete (z.B. Koma-Script) funktionieren jedoch ohne Probleme. XeTeX stellt die derzeitig beste Variante dar, um Unicode-Zeichen in (La)TeX nutzen zu können; weiterführende Informationen finden sich bei der »TeX User Group«: [XeTeX on the Web (englisch)](http://www.tug.org/xetex/).

### XeTeX-unicode-math
Mit XeTeX können Unicode-Zeichen auch im Mathematik-Modus gesetzt werden. Das wird erreicht durch Will Robertsons Paket *unicode-math*, das inzwischen [auf CTAN](http://www.tex.ac.uk/tex-archive/help/Catalogue/entries/unicode-math.html) verfügbar ist. [Hier](../src/branch/master/latex/XeTeX-unicode-math/) befindet sich neben einer Installationsanleitung auch ein Beispiel, das grundliegende Features dieses experimentellen Paketes demonstriert. Die stets aktuelle Entwicklungsversion von *unicode-math* befindet auf [GitHub](http://github.com/wspr/unicode-math).

Der Author Will Robertson führt die Fortentwicklung des Paketes unicode-math momentan regelmäßig weiter, und beschäftigt sich gleichzeitig im Rahmen des [LaTeX3-Projektes](http://www.latex-project.org/latex3.html), um eine ordentliche Grundlage für eine bessere Implementierung von unicode-math zu erarbeiten.

### XeTeX + alttex
Das Paket alttex bietet besonders experimentierfreudigen Neo-Nutzern neue Möglichkeiten, die Vorteile von Neo direkt in (Xe)LaTeX zu verwenden. Das sehr experimentelle Paket ist auf [github](http://github.com/alt/alttex/tree/master) zu finden und richtet sich an erfahrene TeX-Nutzer.

## Standard-LaTeX
Die hier angebotenen Alternativen haben den Vorteil, mit dem »normalen« pdfLaTeX und dem gebräuchlichen Standard-Packet *inputenc* benutzt werden zu können.

### mathletters + utf8x
Mit dem Paket *ucs* (in texlive und mactex enthalten) können durch folgende Einträge in der Präambel die Zeichen der Neo-Tastatur direkt eingegeben und übersetzt werden:  
\usepackage[mathletters]{ucs}  
\usepackage[utf8x]{inputenc}  

### uniinput
Ältere Alternative: [Hier](../src/branch/master/latex/Standard-LaTeX/) befindet sich das Paket uniinput. Es setzt auf die utf8-Kodierung (via inputenc) auf und ergänzt diese um mehrere auf der Neo-Tastatur vorkommende Zeichen (insbesondere aus der Mathematik). Hier werden die über Neo eingegebenen Zeichen also auch als echte Unicode-Zeichen in der TeX-Datei abgespeichert.

### Compose-Erweiterung für Lyx
Einen anderen Weg geht die Compose-Erweiterung [lyx.module](../raw/branch/master/latex/lyx/lyx.module) (die Installationsanleitung für Lyx befindet sich in der Datei). Hier werden die von der Neo-Tastatur gesendeten Unicode-Zeichen (via [Compose](Tote-Tasten-und-Compose)) auf die entsprechenden LaTeX-Konstrukte abgebildet, also auch im ASCII-Format gespeichert (… → `\ldots`). Die Unicodezeichen werden also nur für die Eingabe verwendet.

## LuaTeX
[LuaTeX](http://de.wikipedia.org/wiki/LuaTeX) ist ein sich in der Entwicklung befindliche Nachfolger von TeX, der verschiedene TeX-Weiterentwicklungen in sich vereinen soll. Neben der namensgebenden Integration der Programmiersprache Lua, durch die eine einfache Programmierung ermöglicht werden soll, wird (wie bei XeTeX) auch die Unterstützung von Unicode und moderner Schriftformate angestrebt.

LuaTeX wird voraussichtlich erst im Jahr 2012 die Version 1.0 erreichen, kann jedoch bereits jetzt produktiv benutzt werden, da bereits [ausführbaren Dateien](http://www.luatex.org/download.html) für alle verbreiteten Betriebssysteme erhältlich sind.

Insbesondere die Entwicklungsversion von [ConTeXt](http://wiki.contextgarden.net/) macht rege Gebrauch von LuaTeX; aber es gibt auch schon entsprechende Pakete für LuaLaTeX, etwa Portierungen von *fontspec* oder *unicode-math*. Da diese aber noch experimentell sind und größere Änderungen durchlaufen können, sollte LuaTeX derzeitig nur von fortgeschrittenen Benutzern eingesetzt werden.
