
# Neo und Vim

!!! todo "Todo"
    Verweise auf V2 / V2-flux sind noch nicht eingetragen.
    
!!! tip "Hinweis"
    Es gibt mittlerweile mit [V2](V2) ein Speziallayout, das sich hervorragend für die Arbeit mit vim eignet.

## Das Numpad funktioniert nicht
Das ist kein Neo-spezifisches Problem. Der Fehler ist seit Jahren bekannt und tritt bei sämtlichen integrierten Numpads auf. Für Nutzer von xterm und urxvt gibt es im [Bugreport](http://wiki.neo-layout.org/ticket/182) Abhilfe:

### xterm

```
 Für xterm ergänzt man die VT100-Translations:

XTerm*VT100.translations: \
    :<KeyPress> KP_Add:string("+") \n\
    :<KeyPress> KP_Subtract:string("-") \n\
    :<KeyPress> KP_Multiply:string("*") \n\
    :<KeyPress> KP_Divide:string("/") \n\
    :<KeyPress> KP_Decimal:string(".") \n\
    :<KeyPress> KP_Separator:string(",") \n\
    :<KeyPress> KP_1:string("1") \n\
    :<KeyPress> KP_2:string("2") \n\
    :<KeyPress> KP_3:string("3") \n\
    :<KeyPress> KP_4:string("4") \n\
    :<KeyPress> KP_5:string("5") \n\
    :<KeyPress> KP_6:string("6") \n\
    :<KeyPress> KP_7:string("7") \n\
    :<KeyPress> KP_8:string("8") \n\
    :<KeyPress> KP_9:string("9") \n\
    :<KeyPress> KP_0:string("0") \n\
    …
```

wobei „…“ der bisherige Inhalt der VT100-Translations ist; siehe die xterm man page (und zum Syntax Anhang B von «X Toolkit Intrinsics - C Language Interface»). 

### urxvt
Siehe [urxvt](Urxvt.md)

## Das Steuerkreuz funktioniert nicht
Bis jetzt hat erst  ein Neoling (unter Verwendung der xmodmap) dieses Problem gehabt.

Tritt mindestens in xterm und urxvt auf, die Lösung entspricht vermutlich der Problembehandlung für den Ziffernblock.

## Mappings von Sonderzeichen
In vim gibt es das ungewollte Feature, das alle Mappings ignoriert werden, die in ihrer Unicode-Repräsentation die Sequenz *0x80* haben.
Das betrifft z.B. die Zeichen „–“, „—“ und „•“.

g8 im normal mode zeigt den Unicode-Wert eines Zeichens an. Wenn dort eine *80* vorkommt ist das Mapping leider nicht möglich.

## Neo hat kein HJKL auf der Grundlinie
Kein wirklicher Nachteil. Vim kann viel mehr als zeilenweise Bewegungen. 
Dieses [Poster](http://naleid.com/blog/2010/10/04/vim-movement-shortcuts-wallpaper) gibt einen guten Überblick über die Navigation in vim.
Ansonsten wendet man sich an den vim-Experten seines Vertrauens (z.B. #vim in freenode).

Ein paar Tips für vim-Addons findet man in [Firefox](Firefox.md).
